use SQLsat_xmlBattle
GO

IF OBJECT_ID (N'eConsumtion_xml', N'U') IS NOT NULL 
   DROP TABLE dbo.eConsumtion_xml;


CREATE TABLE  dbo.eConsumtion_xml (
			  ID        int  IDENTITY(1,1) NOT NULL
		    , [key]     nvarchar(50)           NULL
			, xmlValue  xml                    NULL
, CONSTRAINT  PK_eConsumtion_xml PRIMARY KEY CLUSTERED 
           (  ID      ASC   )
);
GO


----  fill in sampledata
DECLARE @ii       int = 1
      , @max      int = 10

DECLARE @xmlValue xml
 
WHILE ( @ii <= @max )
BEGIN
	EXEC dbo.randConsumtionData  @xmlValue OUTPUT
	
	INSERT INTO dbo.eConsumtion_xml
	       ( [key] 
		   , xmlValue )
    VALUES ( 'wert' + RIGHT( '0000' + CAST(@ii as nvarchar(4)) , 4)
	       , @xmlValue )
	----
	SET @ii = @ii + 1
END  -- end WHILE


select * 
from   dbo.eConsumtion_xml
where  ID = 8;
--------------
--------------