-- xml_battle_23_XQuery_indexes

-- !! Requirement:  Primary Key as Clustered Index
-------
-- https://msdn.microsoft.com/en-us/library/ms191497.aspx
-- XML Indexes (SQL Server)

USE SQLsat_xmlBattle;
GO

CREATE PRIMARY XML INDEX IX_primaryXml 
ON  dbo.eConsumtion_xml  ( xmlValue );
GO


CREATE XML INDEX IX_Xml_PATH 
ON  dbo.eConsumtion_xml  ( xmlValue )
USING XML INDEX  IX_primaryXml 
FOR PATH;

CREATE XML INDEX IX_Xml_PROPERTY
ON  dbo.eConsumtion_xml  ( xmlValue )
USING XML INDEX  IX_primaryXml 
FOR PROPERTY;

CREATE XML INDEX IX_Xml_VALUE
ON  dbo.eConsumtion_xml  ( xmlValue )
USING XML INDEX  IX_primaryXml 
FOR VALUE;
GO

----------
----------