-- xml_battle_24_XQuery_FLWOR
USE SQLsat_xmlBattle;
GO


SELECT *
     , xmlValue.query('CustomerData/Customer/CustID')  as 'xmlFragment'
	 , xmlValue.query('CustomerData/Customer/CustID/node()')  as 'xmlResult'
	 , xmlValue.query('CustomerData/Customer/CustID/text()')  as 'xmlText'
FROM   dbo.eConsumtion_xml;

----
-- sample FLWOR
SELECT ID, [key], xmlValue
     , xmlValue.value('(CustomerData/Customer/CustID)[1]', 'nvarchar(40)' )  as 'nvarchar_CustID'
	 , xmlValue.query(' for $i in CustomerData/Customer/CustID
	                    let $j := CustomerData/Customer/Consumtion/consumtionValue
						where  avg($j) >= 5
						return
						<result>
						   {data($j)}
                        </result>
	                  ') as 'data'
     , xmlValue.query(' for $i in CustomerData/Customer/CustID
	                    let $j := CustomerData/Customer/Consumtion/consumtionValue
						where  avg($j) >= 5
						return
						<result>
						   <count>  {count($j)} </count>
						   <sum>    {sum($j)}   </sum>
						   <avg>    {avg($j)}   </avg>
                        </result>
	                  ') as 'summary'
FROM   dbo.eConsumtion_xml;

----
-- VIEW with "calculated Values"
CREATE VIEW dbo.eConsumtion_Details
AS
SELECT ID, [key], xmlValue
     , xmlValue.value('(CustomerData/Customer/CustID)[1]', 'nvarchar(40)' )  as 'nvarchar_CustID'
	 , xmlValue.query(' for $i in CustomerData/Customer/CustID
	                    let $j := CustomerData/Customer/Consumtion/consumtionValue
						
						return
						<result>
						   {data($j)}
                        </result>
	                  ') as 'data'
     , xmlValue.query(' for $i in CustomerData/Customer/CustID
	                    let $j := CustomerData/Customer/Consumtion/consumtionValue
						 
						return
						<result>
						   <count>  {count($j)} </count>
						   <sum>    {sum($j)}   </sum>
						   <avg>    {avg($j)}   </avg>
                        </result>
	                  ') as 'summary'
FROM   dbo.eConsumtion_xml;

----------
----------

SELECT [key], xmlValue, summary
     , summary.value('(result/count)[1]', 'int' )  as 'count'
	 , summary.value('(result/sum)[1]'  , 'int' )  as 'sum'
	 , summary.value('(result/avg)[1]'  , 'int' )  as 'avg'
FROM   dbo.eConsumtion_Details
----------
----------